#ifndef __COMPONENT_H
#define __COMPONENT_H

#include <hpcxx_rts.h>
#include "MyGlobalPointerPack.h"
#include "Constants.h"
#include <string.h>
#include "HPCxx_Comm.h"
#include "HPCxx_String.h"
#include "HPCxx_Arrays.h"
#include "RMIRegistry.h"
#include "TestObj.h"
#include "BindObject.h"
#include <stdio.h>

class Dummy {
public:
  int isItNULL;
  Dummy() : isItNULL(1) {}
  Dummy(int nullValue) : isItNULL(nullValue) {}
  Dummy(Dummy& source) {
    this->isItNULL = source.isItNULL;
  }
  Dummy& operator=(Dummy& source) {
    this->isItNULL = source.isItNULL;
    return *this;
  }
};

class Component {
private:

public:
  Component();
  MyHPCxx_GlobalPtr<Dummy> instantiateComponent(HPCxx_String, HPCxx_String, HPCxx_String FQN);
  static int registrationID()  { return 350; }
  static HPCxx_String getFullyQualifiedClassName() {
    return "GramServer.ServerImpl";
  };
  ~Component();

friend void hpcxx_pack(HPCxx_Buffer &buf, Component *t,int count);
friend void hpcxx_unpack(HPCxx_Buffer &buf, Component *t,int count);
  
};


#endif // COMPONENT_H


















